# xml-validation

HTML-Server written in Python for validation of xml (e.g. DCC xml) against a 
XML Schema.

## Notizen

»lxml« und »xmllint« verwenden beide die Linux/Unix-Bibliotheken »libxml2« und 
»libxslt«. 

### Hinweise zur Python-Bibliothek »lxml«

* [Home-Page](https://lxml.de/)
* [Einfache Beispiele](https://stackoverflow.com/questions/299588/validating-with-an-xml-schema-in-python)
 
 
### Hinweise zur Python-Bibliothek »xmlschema« 

* [Home-Page](https://xmlschema.readthedocs.io/en/latest/usage.html)
* [Einfache Beispiele](https://stackoverflow.com/questions/299588/validating-with-an-xml-schema-in-python)

### Hinweise zu »xmllint«
```
xmllint --noout --schema DCC_v1.8.1.xsd 11044_17_DCC_v1.8.1_Au.xml
xmllint --valid --noout 11044_17_DCC_v1.8.1_Au.xml
```

### Installation

```
> git clone git@a75436.berlin.ptb.de:vaclab/xml-validation.git
> cd xml-validation
> python3 -m venv .
> source bin/activate
> pip install flask flask_cors xmlschema requests
> ./server
```

## API

### /is_valid endpoint [POST]


```
> curl -X POST -H "Content-Type: text/xml" -d @valid_xml_matches_xsd http://localhost:5005/is_valid
> <ok/>
```

```
> curl -X POST -H "Content-Type: text/xml" -d @no_valid_xml http://localhost:5005/is_valid
> <error>unvalid xml data</error>
```

```
> curl -X POST -H "Content-Type: text/xml" -d @valid_xml_but_dont_matches_xsd http://localhost:5005/is_valid
> <error>not valid</error>
```

Example:

```
> curl -X POST -H "Content-Type: text/xml" -d @11044_17_DCC_v1.8.1_Au.xml http://localhost:5005/is_valid
> <ok/>
```

### /version [GET]

Returns the version of the validation server:

```
> curl http://localhost:5005/version
> <version>0.2.0</version>
```
